#define F_CPU 8000000
#include <avr/io.h>
#include <util/delay.h>
#include <string.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <stdlib.h>

#define MYUBRR 51

volatile unsigned long long counter_1 =0;
char buffer[64];
volatile int bufferIndex = 0;
char hallSensorStr[10];


inline void USART_Init()
{
	UBRR0H = ((unsigned char)(MYUBRR>>8));
	UBRR0L = ((unsigned char)MYUBRR);
	UCSR0B = (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0);
	UCSR0C = (3<<UCSZ00);
}  

void serialSend(char* sendString){
	for (int i = 0; i < strlen(sendString); i++){
		while (( UCSR0A & (1<<UDRE0))  == 0){};
		UDR0 = sendString[i];
		_delay_ms(1);
	}
}
void Process_UART_RX(){
	if(bufferIndex > 0){
		serialSend("Speed: ");
		serialSend(buffer);
		
		OCR2 = abs(255 - atoi(buffer));
		
		for(int i=0;i<64;i++)
		buffer[i] = 0;
		
		bufferIndex = 0;
		serialSend("\n");
	}
}

int direction_counter = 0;
ISR(INT4_vect) { 
	counter_1++;
	
}


ISR(USART0_RX_vect){
	
	char rcvChar = UDR0;
	if(rcvChar != '\n')
	{
		buffer[bufferIndex] = rcvChar;
		bufferIndex++;
	}
	
}

void initInterrupt4() {
EIMSK = (1 << INT4); /* enable INT4 */
EICRB = 1; /* trigger when button changes */
PORTE = 0b00000000;

}
int speed = 0xFF;
ISR(TIMER1_COMPA_vect) {
	PORTA ^= (3<<0);
	itoa(counter_1 ,hallSensorStr,10);
	counter_1 = 0;
	serialSend(hallSensorStr);
	serialSend("\n");

}
	
static inline void initTimer1(void) {
	TCCR1B |= (1 << WGM12); /* CTC mode */
	TCCR1B |= (1 << CS11) | (1<<CS10);//(1 << CS12);
	// (1 << CS12) ---> 1 second
	//(1 << CS11) | (1<<CS10) 0.25 sec.
	TIMSK |= (1 << OCIE1A); /* enable output compare interrupt */
	OCR1A = 31250;
}
void initPWM(){
	TCCR2 |= (1<<WGM21) | (1<<WGM20) | (1<<WGM20) |(1<<COM21) |(1<<COM20) |(1<<CS21) | (1<<CS20);
	OCR2 = 0xFF;
}
int main (void)
{
	for(int i=0;i<64;i++)
		buffer[i] = 0;
	
	DDRA = 0b00000011;
	DDRD = 0b00000011;
	DDRB = 0b10000000;
	
	USART_Init();
	initInterrupt4();
	initTimer1();
	initPWM();
 	
	sei();
	
	
	for(;;){
		Process_UART_RX();
	}
}
